﻿using System;
using System.IO;

using My.Collections;


namespace CompanySearch
{
    public class Companies
    {
        private BinaryTree<Company> companies = new BinaryTree<Company>(); 

        public Companies(TextReader r)
        {
            // Spaltenüberschriften auslesen
            var tokens = r.ReadLine().Split(new char[] { ';' });
            if (tokens.Length != 3)
                throw new ArgumentException("More than 3 columns in company file");
            
            string line;
            while ((line = r.ReadLine()) != null)
            {
                tokens = line.Split(new char[] { ';' });

                companies.Add(new Company()
                {
                    Bezeichnung = tokens[0],
                    Branche = tokens[1],
                    Ort = tokens[2]
                });
            }
            r.Close();
        }

        public Company Read(string bezeichnung)
        {
            return companies.Search(new Company() { Bezeichnung = bezeichnung });
        }
    }

    public class Company : IComparable<Company>
    {
        public string Bezeichnung { get; set; }
        public string Branche { get; set; }
        public string Ort { get; set; }

        public int CompareTo(Company other)
        {
            return Bezeichnung.CompareTo(other.Bezeichnung);               
        }

        public override string ToString()
        {
            return string.Format("Bezeichnung: {0}\tBranche: {1}\tOrt: {2}", Bezeichnung, Branche, Ort);
        }
    }
}
