﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Text;


namespace Hangman
{
    class Game
    {
        private List<string> words;
        private string word;
        private string currWord;
        private int penaltyPoints;

        public void Initialize()
        {
            words = new List<string>();

            using (var stream = new StreamReader(@"..\Testdaten\german.dic", Encoding.Default))
            {
                while(!stream.EndOfStream)
                {
                    var word = stream.ReadLine(); 
                    if(!word.StartsWith("%"))
                        words.Add(word.ToLower());
                }
            }
        }

        public bool Loop()
        {
            start();

            while(word != currWord)
            {
                Console.WriteLine(currWord);
                var key = Console.ReadKey();

                if (key.Key == ConsoleKey.Escape)
                    return false;

                int n = word.IndexOf(key.KeyChar);
                if (n < 0)
                    penaltyPoints++;
                else
                    currWord = adapt(key.KeyChar);
                
                Console.WriteLine();
            }

            Console.WriteLine(string.Format("Sie haben das Wort '{0}' mit {1} inkorrekten Buchstaben geraten!", word, penaltyPoints));
            
            return true;
        }

        private void start()
        {
            var r = new Random();
            word = words[r.Next(words.Count)];

            penaltyPoints = 0;

            Console.Clear();
            Console.WriteLine(string.Format("Ende = Esc-Taste\nNeues Spiel: Das Wort hat {0} Buchstaben", word.Length));
            currWord = "".PadLeft(word.Length, '_');
        }

        private string adapt(char c)
        {
            string current = "";

            for (int i = 0; i < word.Length; i++)
                current += word[i] == c ? c : currWord[i];

            return current;
        }
    }
}
