﻿using System;
using My.Collections;
using System.Threading.Tasks;
using System.IO;
using System.Text;
using System.Diagnostics;

namespace Sort
{
    class Program
    {
        private delegate void delegates();

        static void Main(string[] args)
        {
            var list = new SortedArrayList<int>();

            delegates[] funcs = new delegates[] 
                            { 
                               //new delegates(list.BubbleSort), 
                               //new delegates(list.InsertionSort), 
                               new delegates(list.QuickSort), 
                               new delegates(list.BucketSort), 
                               new delegates(list.MergeSort)
                            };

            var w = new Stopwatch();

            foreach(var func in funcs)
            {
                list.AddRange(new int[] { 8, 7, 3, 5, 9, 4, 1 });

                w.Restart();
                func();
                w.Stop();

                Console.WriteLine(func.Method.ToString() + ": " + list.ToString());
                Console.WriteLine(w.ElapsedTicks);
                list.Clear();
            }
            Console.ReadLine();
        }
    }
}
